
def zip_longest(*args, fillvalue=()):
    """Combine several iterables into tuples of equal length, filling missing values with fillvalue."""
    iterators = [iter(arg) for arg in args]
    while True:
        result = [next(it, fillvalue) for it in iterators]
        if fillvalue in result:
            return
        yield tuple(result)

